Attribute VB_Name = "DeterminationWindowsVersion"
Option Explicit

Public Enum WindowsVersion
    Unknown = -1
    Win95
    Win98
    WinME
    WinNT3
    WinNT4
    Win2000
    WinXP
End Enum

Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Public Function DeterminateWindowsVersion() As WindowsVersion

    ':
    '  0-Error
    '  1-Win 95
    '  2-Win 98
    '  3-Win Me
    '  4-Win NT 3.51
    '  5-Win NT 4.0
    '  6-Win 2k
    '  7-Win XP
    
    Dim osinfo As OSVERSIONINFO
    Dim retvalue As Integer
    Dim Res As WindowsVersion
    
    osinfo.dwOSVersionInfoSize = 148
    osinfo.szCSDVersion = Space$(128)
    retvalue = GetVersionEx(osinfo)
    
    With osinfo
        Select Case .dwPlatformId
            Case 1
                Select Case .dwMinorVersion
                    Case 0
                        Res = Win95
                    Case 10
                        Res = Win98
                    Case 90
                        Res = WinME
                End Select
            Case 2
                Select Case .dwMajorVersion
                    Case 3
                        Res = WinNT3
                    Case 4
                        Res = WinNT4
                    Case 5
                        If .dwMinorVersion = 0 Then
                            Res = Win2000
                        Else
                            Res = WinXP
                        End If
                End Select
            Case Else
               Res = Unknown
        End Select
    End With
    DeterminateWindowsVersion = Res
End Function

Public Function ConvertWindowsVersionToString(WinVer As WindowsVersion) As String
    Select Case WinVer
        Case Win95:
            ConvertWindowsVersionToString = "Windows 95"
        Case Win98:
            ConvertWindowsVersionToString = "Windows 98"
        Case WinME:
            ConvertWindowsVersionToString = "Windows ME"
        Case WinNT3:
            ConvertWindowsVersionToString = "Windows NT 3"
        Case WinNT4:
            ConvertWindowsVersionToString = "Windows NT 4"
        Case Win2000:
            ConvertWindowsVersionToString = "Windows 2000"
        Case WinXP:
            ConvertWindowsVersionToString = "Windows XP"
        Case Else:
            ConvertWindowsVersionToString = "Unknown"
    End Select
End Function
